/***************************************************************************
Name: JSView
Description: View the source code of external js and css files
Author: Ron Beckman

Copyright (C) 2008  Ron Beckman

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

Free Software Foundation, Inc.
51 Franklin Street
Fifth Floor
Boston, MA  02110-1301
USA
***************************************************************************/


window.addEventListener('unload',function() {jsviewBehavior.exit();},false);

var jsviewObserver = {

	init: function() {
		var os = this.getObserver();
		os.addObserver(this, 'jsview-url-changed', false);
	},

	uninit: function() {
		var os = this.getObserver();
		os.removeObserver(this, 'jsview-url-changed');
	},

	QueryInterface : function(aIID) {
		if (aIID.equals(Components.interfaces.nsISupports) ||
		    aIID.equals(Components.interfaces.nsIObserver))
			return this;
		throw Components.results.NS_NOINTERFACE;
	},

	getObserver: function() {
		return Components.classes['@mozilla.org/observer-service;1'].
		getService(Components.interfaces.nsIObserverService);
	},

	/*
	   aSubject: null
	   aTopic: 'jsview-url-changed'
	   aData: new url string
	*/
	observe: function(aSubject, aTopic, aData) {
		if (aTopic == 'jsview-url-changed' && aData) {
			jsviewBehavior.setTextBoxVal(aData);
		}
	}
};

var jsviewBehavior = {

	init: function() {
		jsviewObserver.init();
		this.setTextBoxVal(window.arguments[0]);
	},

	exit: function() {
		try { jsviewObserver.uninit(); } catch (e) { }
	},

	setTextBoxVal: function(url) {
		document.getElementById('url').value = url;
	},

	copyLink: function() {
		var url = document.getElementById('url').value;
		jsvutils.copyToClipboard(url);
		window.close();
	},

	viewSource: function(type) {
		var url = document.getElementById('url').value;
		jsvutils.viewSource(url,type);
		window.close();
	}
};
